///////////////////////////////////////////////////////////////////////////////
// Win32 Application Template
///////////////////////////////////////////////////////////////////////////////
#include	<windows.h>
#include	"resource.h"

char	szWinName[] = "Template";	// EBhENX̖O

ATOM InitApplication(HINSTANCE hInstance);
HWND InitInstance(HINSTANCE hInstance, int nCmdShow);
LRESULT CALLBACK WindowFunc(HWND hWnd, UINT uMes, WPARAM wp, LPARAM lp);
BOOL QuitMessage(HWND hWnd);
BOOL CALLBACK DialogProc(HWND hDlg, UINT uMes, WPARAM wp, LPARAM lp);

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
				   LPSTR lpCmdLine, int nCmdShow){
	HWND				hWnd;
	MSG					msg;
	
	if(!InitApplication(hInstance))
		return FALSE;
	
	if(NULL == (hWnd = InitInstance(hInstance, nCmdShow)))
		return FALSE;
	
	// bZ[W[v𐶐
	while(1){
		if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
			if(msg.message == WM_QUIT)
				break;
			TranslateMessage(&msg);	// L[{[hgp\ɂ
			DispatchMessage(&msg);	// Rg[Windowsɖ߂
		}
		// Idle
	}
	
	return msg.wParam;
}

ATOM InitApplication(HINSTANCE hInstance){
	WNDCLASSEX	wcl;

	// EBhENX`
	wcl.hInstance = hInstance;		// ̃CX^X̃nh
	wcl.lpszClassName = szWinName;	// EBhENX
	wcl.lpfnWndProc = WindowFunc;	// EBhE֐
	wcl.style = 0;					// ftHg̃X^C
	wcl.cbSize = sizeof(WNDCLASSEX);// WNDCLASSEX\̂̃TCY
	wcl.hIcon = NULL;				// [WACR
	wcl.hIconSm = NULL;				// X[ACR
	wcl.hCursor = LoadCursor(NULL, IDC_ARROW);
									// J[\X^C
	wcl.lpszMenuName = MAKEINTRESOURCE(IDR_MENU1);
									// j[
	wcl.cbClsExtra = 0;				// GLXgȂ
	wcl.cbWndExtra = 0;				// KvȃCtH[V

	// EBhE𔒂ɂ
	wcl.hbrBackground = (HBRUSH)GetStockObject(WHITE_BRUSH);

	// EBhENXo^
	return RegisterClassEx(&wcl);
}

HWND InitInstance(HINSTANCE hInstance, int nCmdShow){
	HWND		hWnd;

	// EBhENX̓o^ł̂ŁCEBhENGCgł
	hWnd = CreateWindow(
		szWinName,					// EBhENX̖O
		"Template",					// ^Cg
		WS_OVERLAPPEDWINDOW,		// EBhEX^C-m[}
		CW_USEDEFAULT,				// XW-WindowsɔC
		CW_USEDEFAULT,				// YW-WindowsɔC
		CW_USEDEFAULT,				// -WindowsɔC
		CW_USEDEFAULT,				// -WindowsɔC
		HWND_DESKTOP,				// eEBhEȂ
		NULL,						// j[Ȃ
		hInstance,					// ̃vÕCX^X̃nh
		NULL						// ǉȂ
	);
	if(NULL == hWnd)
		return NULL;

	// EBhE\
	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	return hWnd;
}

// ̊֐́CWindowsĂяoāCbZ[WL[
// bZ[Ẅn󂯂
LRESULT CALLBACK WindowFunc(HWND hWnd, UINT uMsg, WPARAM wp, LPARAM lp){
	HINSTANCE			hInstance;
	
	hInstance = (HINSTANCE)GetWindowLong(hWnd, GWL_HINSTANCE);
	
	switch(uMsg){
	case WM_CREATE:					// EBhE̍쐬
		break;
	case WM_DESTROY:				// ~Ƃ̏
		PostQuitMessage(0);			// EBhȄID0  Exit code
		break;
	case WM_CLOSE:					// eEBhEWM_DESTROY𔭍s
		if(QuitMessage(hWnd)){		// I̊mF
			DestroyWindow(hWnd);	// CEBhE̔jDWM_DESTROYs
		}
		break;
	case WM_COMMAND:
		switch(LOWORD(wp)){
		case IDM_QUIT:
			PostMessage(hWnd, WM_CLOSE, 0, 0L);;
			break;
		case IDM_EDIT:
			DialogBox(hInstance, MAKEINTRESOURCE(IDD_DIALOG1), hWnd,
				(DLGPROC)DialogProc);
			break;
		}
		break;
	default:						// LȊOWindowsɏ
		return DefWindowProc(hWnd, uMsg, wp, lp);
	}
	return 0;
}

BOOL QuitMessage(HWND hWnd){
	if(MessageBox(hWnd, (LPCSTR)"I܂H", (LPCSTR)"ImF",
		MB_YESNO | MB_ICONQUESTION) == IDYES)
		return TRUE;
	return FALSE;
}

BOOL CALLBACK DialogProc(HWND hDlg, UINT uMes, WPARAM wp, LPARAM lp){
	char				lpszMessage[128] = "";

	switch(uMes){
	case WM_INITDIALOG:
		SetDlgItemText(hDlg, IDC_TEXT, lpszMessage);
		break;
	case WM_COMMAND:
		switch(LOWORD(wp)){
		case IDOK:
			GetDlgItemText(hDlg, IDC_EDIT1, lpszMessage, 128);
			SetDlgItemText(hDlg, IDC_TEXT, lpszMessage);
			break;
		case IDCANCEL:
			EndDialog(hDlg, 0);
			return TRUE;
		}
		break;
	}
	return FALSE;
}
